(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: colormapping_print.ml,v 1.1 2014/06/17 10:54:09 fclement Exp $ *)

let print_color_scale = Lib_print.print_Array Colors_print.print_t;;

let print_from_float = Lib_print.print_quoted_float
and print_to_float = Lib_print.print_quoted_float
;;

let print_mapping =
    Lib_print.print_fun print_color_scale
     (Lib_print.print_fun print_from_float
        (Lib_print.print_fun print_to_float
           (Lib_print.print_fun
              Lib_print.print_quoted_float
              Colors_print.print_t)))
;;

let print_t ppf = function
  | {
      Colormapping.color_scale = c;
      Colormapping.from_float = f;
      Colormapping.to_float = t;
      Colormapping.mapping = m;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>color_scale =@ "; print_color_scale ppf c;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>from_float =@ ";
    print_from_float ppf f; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>to_float =@ "; print_to_float ppf t;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>mapping =@ ";
    print_mapping ppf m; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@,}@]"
;;
