(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uaffine_plane_spec.mli,v 1.2 2014/07/11 12:32:38 fclement Exp $ *)

module type STRUCTURE =
sig
  type t;;
  
  val _0_ : t;;
  val _1_ : t;;
  
  val add : t -> t -> t;;
  val sub : t -> t -> t;;
end
;;

module type AFFINE_PLANE =
sig
  type component;;
  
  type point = component * component;;
  type vector = component * component;;
  
  val origin : point;;
  val null : vector;;
  
  val add : point -> vector -> point;;
  val sub : point -> point -> vector;;
end
;;

module type MAKER =
  functor (S : STRUCTURE) ->
  AFFINE_PLANE with type component = S.t
;;
