(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_index ppf = function
  | u_i -> Umatrix_nonempty_set_print.print_index ppf u_i

and print_uindex ppf = function
  | u_u -> Umatrix_nonempty_set_print.print_uindex ppf u_u
;;

let print_domain ppf = function
  | u_t -> Umatrix_nonempty_set_print.print_t ppf u_t
;;

let print_sub_domain ppf = function
  | u_n -> Umatrix_nonempty_set_print.print_nonempty_subset ppf u_n
;;

let print_images pp_a ppf = function
  | Umatrix_graph.Constant a ->
    Format.fprintf ppf "@[<1>%s@ " "Constant"; pp_a ppf a;
    Format.fprintf ppf "%,@]"
  | Umatrix_graph.Images a_a ->
    Format.fprintf ppf "@[<1>%s@ " "Images";
    Lib_print.print_Array pp_a ppf a_a; Format.fprintf ppf "%,@]"
;;

let print_t pp_a ppf = function
  | { Umatrix_graph.domain = d; Umatrix_graph.images = a_i; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>domain =@ ";
    print_domain ppf d; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>images =@ "; print_images pp_a ppf a_i;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
